Package org.jfree.layouting.renderer.model

## Class NormalFlowRenderBox

- java.lang.Object
- - org.jfree.layouting.renderer.model.RenderNode
  - - org.jfree.layouting.renderer.model.RenderBox
    - - org.jfree.layouting.renderer.model.BlockRenderBox
      - - org.jfree.layouting.renderer.model.NormalFlowRenderBox

-     public class NormalFlowRenderBox
      extends BlockRenderBox

  A box that defines its own normal flow. All absolutly positioned or floating elements define their own normal flow. Each flow contains an invisible place-holder element, which marks the position of that element in the parent's normal-flow. A flow may hold a set of sub-flows. Sub-Flows are derived from floating elements. Absolutely positioned elements are placed on the page context. Normal-flows are derived for each absolutly or staticly positioned element.
  Author:
    Thomas Morgner

- - ### Field Summary

    - ### Fields inherited from class org.jfree.layouting.renderer.model.RenderBox

      `LOG_PRUNE`

    - ### Fields inherited from class org.jfree.layouting.renderer.model.RenderNode

      `HORIZONTAL_AXIS, VERTICAL_AXIS`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NormalFlowRenderBox​(BoxDefinition boxDefinition)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addChild​(RenderNode child)` |
    `void` | `addFlow​(NormalFlowRenderBox flow)` |
    `void` | `appyStyle​(LayoutContext context, OutputProcessorMetaData metaData)` |
    `RenderNode` | `derive​(boolean deepDerive)` | Derive creates a disconnected node that shares all the properties of the original node.
    `RenderNode` | `deriveFrozen​(boolean deepDerive)` | Derive creates a disconnected node that shares all the properties of the original node.
    `RenderNode` | `findNodeById​(java.lang.Object instanceId)` |
    `NormalFlowRenderBox` | `getFlow​(int i)` |
    `int` | `getFlowCount​()` |
    `NormalFlowRenderBox[]` | `getFlows​()` |
    `RenderBox` | `getInsertationPoint​()` |
    `NormalFlowRenderBox` | `getNormalFlow​()` |
    `PlaceholderRenderNode` | `getPlaceHolder​()` |
    `RenderNode` | `hibernate​()` | Derive creates a disconnected node that shares all the properties of the original node.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from class org.jfree.layouting.renderer.model.RenderBox

      `addChilds, addGeneratedChild, clear, clone, close, freeze, getBaselineInfo, getBorder, getBoxDefinition, getBoxLayoutProperties, getContentAreaX1, getContentAreaX2, getDominantBaseline, getEffectiveMarginBottom, getEffectiveMarginTop, getFirstChild, getLastChild, getLineCount, getNominalBaselineInfo, getOrphans, getOrphansSize, getPageContext, getStaticBoxLayoutProperties, getVisibleFirst, getVisibleLast, getWidows, getWidowsSize, insertAfter, insertBefore, isAppendable, isAvoidPagebreakInside, isDiscardable, isEmpty, isOpen, isPreserveSpace, remove, replaceChild, replaceChilds, setBaselineInfo, setContentAreaX1, setContentAreaX2, setFirstChild, setLastChild, setLineCount, setOrphansSize, setPageContext, setWidowsSize, split`

    - ### Methods inherited from class org.jfree.layouting.renderer.model.RenderNode

      `getAlignmentAdjust, getAlignmentAdjustResolved, getAlignmentBaseline, getBaselineShift, getBaselineShiftResolved, getChangeTracker, getComputedLayoutProperties, getDimension, getHeight, getInstanceId, getLayoutContext, getLogicalPage, getMajorAxis, getMaximumBoxWidth, getMinimumChunkWidth, getMinorAxis, getNamespace, getNext, getNodeLayoutProperties, getParent, getParentBlockContext, getPosition, getPrev, getStickyMarker, getTagName, getVerticalAlignment, getVisibleNext, getVisiblePrev, getWidth, getX, getY, isDirectionLTR, isDirty, isFrozen, isHibernated, isIcmMetricsFinished, isIgnorableForRendering, normalizeAlignment, setComputedLayoutProperties, setDimension, setDirty, setHeight, setHibernated, setIcmMetricsFinished, setMajorAxis, setMaximumBoxWidth, setMinimumChunkWidth, setMinorAxis, setNext, setParent, setPosition, setPrev, setStickyMarker, setWidth, setX, setY, updateChangeTracker`

- - ### Constructor Detail

    - #### NormalFlowRenderBox

          public NormalFlowRenderBox​(BoxDefinition boxDefinition)

  - ### Method Detail

    - #### appyStyle

          public void appyStyle​(LayoutContext context,
                                OutputProcessorMetaData metaData)

      Overrides:
        `appyStyle` in class `RenderBox`

    - #### getPlaceHolder

          public PlaceholderRenderNode getPlaceHolder​()

    - #### addChild

          public void addChild​(RenderNode child)

      Overrides:
        `addChild` in class `RenderBox`

    - #### addFlow

          public void addFlow​(NormalFlowRenderBox flow)

    - #### getFlows

          public NormalFlowRenderBox[] getFlows​()

    - #### getFlow

          public NormalFlowRenderBox getFlow​(int i)

    - #### getFlowCount

          public int getFlowCount​()

    - #### hibernate

          public RenderNode hibernate​()

      Derive creates a disconnected node that shares all the properties of the original node. The derived node will no longer have any parent, silbling, child or any other relationships with other nodes.
      Overrides:
        `hibernate` in class `RenderBox`
      Returns:

    - #### derive

          public RenderNode derive​(boolean deepDerive)

      Derive creates a disconnected node that shares all the properties of the original node. The derived node will no longer have any parent, silbling, child or any other relationships with other nodes.
      Overrides:
        `derive` in class `RenderBox`
      Returns:

    - #### deriveFrozen

          public RenderNode deriveFrozen​(boolean deepDerive)

      Derive creates a disconnected node that shares all the properties of the original node. The derived node will no longer have any parent, silbling, child or any other relationships with other nodes.
      Overrides:
        `deriveFrozen` in class `RenderBox`
      Returns:

    - #### getInsertationPoint

          public RenderBox getInsertationPoint​()

      Overrides:
        `getInsertationPoint` in class `RenderBox`

    - #### getNormalFlow

          public NormalFlowRenderBox getNormalFlow​()

      Overrides:
        `getNormalFlow` in class `RenderNode`

    - #### findNodeById

          public RenderNode findNodeById​(java.lang.Object instanceId)

      Overrides:
        `findNodeById` in class `RenderBox`